extern crate hlua;

use hlua::Lua as LuaContext;

pub trait ScriptLang {
    fn init(&mut self);
    fn update(&mut self, delta: f32);
}

pub struct Lua {
    ctx: LuaContext<'static>,
}

impl Lua {
    pub fn new() -> Self {
	Lua {
	    ctx: LuaContext::new(),
	}
    }
}

impl ScriptLang for Lua {
    fn init(&mut self) {
	self.ctx.openlibs();
	//self.ctx.execute::<()>("print(\"Hello!\")").unwrap();
	self.ctx.execute_from_reader::<(), std::fs::File>(std::fs::File::open(&std::path::Path::new("main.lua")).unwrap()).unwrap();
    }

    fn update(&mut self, delta: f32) {
	todo!();
    }
}
